#!/usr/bin/env node
import t from "chalk";
import { execSync as m } from "node:child_process";
import l, { resolve as P } from "node:path";
import d, { existsSync as N, rmSync as u } from "node:fs";
import a from "prompts";
import { onPromptFormStateForSigint as f, lookForParentTarget as R } from "@done-coding/node-tools";
import { getConfigPath as b, batchHandler as D } from "@done-coding/cli-template";
import { getTargetRepoUrl as _ } from "@done-coding/cli-git";
import M from "yargs";
import { hideBin as O } from "yargs/helpers";
const g = {
  version: "0.9.1-alpha.0",
  name: "create-done-coding",
  description: "项目创建命令行工具",
  cliConfig: {
    namespaceDir: ".done-coding",
    moduleName: "create"
  }
}, L = "git@gitee.com:justsosu/done-coding-cli-config-json.git", $ = "自定义模版路径", C = "某个git平台用户仓库", I = `./.${g.name}_temp`;
let v;
const U = async () => (v || (v = (await J()).templateList), v), j = async () => [
  ...await U(),
  { name: $ },
  { name: C }
], A = {
  type: "text",
  name: "projectName",
  message: "请输入项目名称",
  format: (e) => e.trim(),
  validate: (e) => e.length > 0 || "项目名称不能为空",
  onState: f
}, H = async () => ({
  type: "select",
  name: "template",
  message: "请选择模板",
  choices: (await j()).map((o) => ({
    title: o.name,
    value: o.name
  })),
  validate: (o) => o.trim().length > 0 || "模板不能为空",
  onState: f
}), k = {
  type: "confirm",
  name: "saveGitHistory",
  message: "是否保留git历史",
  initial: !1
}, S = (e = "项目已存在，是否删除") => ({
  type: "confirm",
  name: "isRemove",
  message: e
}), B = {
  type: "text",
  name: "customUrl",
  message: "请输入自定义模板路径",
  validate: (e) => e.trim().length > 0 || "路径不能为空",
  onState: f
}, Y = (e) => ({
  type: "text",
  name: "gitCommitMessage",
  message: "请输入git提交信息",
  initial: `feat: 初始化项目${e}`,
  validate: (o) => o.trim().length > 0 || "提交信息不能为空",
  onState: f
}), J = async () => {
  console.log(t.blue("拉取模板列表，请稍等..."));
  const e = l.resolve(
    process.cwd(),
    I
  );
  if (console.log(t.blue(`配置临时目录：${e}`)), d.existsSync(e)) {
    const i = `${e}目录已存在，是否删除？`, { isRemove: n } = await a(S(i));
    n ? d.rmSync(e, { recursive: !0, force: !0 }) : (console.log(t.red(`${e}已存在，请手动删除后再试！`)), process.exit(1));
  }
  m(`git clone ${L} ${e} --depth=1`);
  const o = g.name, h = l.resolve(e, `${o}.json`), r = JSON.parse(d.readFileSync(h, "utf-8"));
  if (!Array.isArray(r.templateList))
    throw new Error("远程配置文件出错，templateList 不是数组");
  return console.log(t.green("模板列表拉取成功！")), d.rmSync(e, { recursive: !0, force: !0 }), r;
}, x = async (e) => {
  const { projectName: o } = e, r = ((o ?? (await a(A)).projectName) || "").trim();
  if (!r)
    return console.log(t.red("项目名称不能为空")), process.exit(1);
  if (r.includes(" ") || r.includes("\\") || r.includes("/"))
    return console.log(t.red(`项目名称\`${r}\`不能包含空格或者\\或者/`)), process.exit(1);
  const i = P(process.cwd(), r);
  if (N(i)) {
    const { isRemove: s } = await a(S());
    if (s === !0)
      u(i, { recursive: !0, force: !0 });
    else
      return console.log(t.red("项目已存在")), process.exit(1);
  }
  const { template: n } = await a(await H());
  let p = "";
  if (n === $) {
    const { customUrl: s } = await a(B);
    p = s;
  } else if (n === C)
    p = await _();
  else {
    const s = (await j()).find(
      (c) => c.name === n
    );
    if (!s)
      return console.log(t.red(`模板${n}不存在`)), process.exit(1);
    if (!s.url)
      return console.log(t.red(`模板${n}仓库地址不存在`)), process.exit(1);
    p = s.url;
  }
  const y = R(".git");
  console.log(t.blue("正在初始化项目，请稍等...")), m(`git clone ${p} ${r} --depth=1`, {
    stdio: "inherit"
  });
  const w = b(i);
  if (w && (await D({
    rootDir: i,
    extraEnvData: {
      $projectName: r
    }
  }), u(w, { force: !0 }), console.log(t.blue("模板项目配置注入成功, 模版项目配置文件已删除"))), console.log(t.blue("项目初始化完成")), y) {
    const s = l.resolve(i), c = l.resolve(s, ".git");
    if (!N(c))
      throw new Error("git目录不存在");
    u(c, { recursive: !0, force: !0 }), console.log(
      t.green(
        `项目创建在父级git仓库${y}中，已删除${r}目录下的.git(${c})`
      )
    );
  } else if ((await a(k)).saveGitHistory)
    m("git remote rename origin upstream && git fetch --unshallow", {
      cwd: i,
      stdio: "inherit"
    }), console.log(
      t.green(
        "已经将origin重命名为upstream，后续可以与模板git仓库有完整的交互"
      )
    ), console.log(t.green("已保存git历史记录"));
  else {
    const c = l.resolve(i, ".git");
    u(c, { recursive: !0, force: !0 }), m("git init", {
      cwd: i,
      stdio: "inherit"
    });
  }
  const { gitCommitMessage: F } = await a(
    Y(r)
  );
  m(`git add . && git commit -m '${F}'`, {
    cwd: i,
    stdio: "inherit"
  }), console.log(t.green(`项目${r}初始化完成`)), console.log(
    t.blue(`
使用步骤: 
  1. cd ${r}
  2. pnpm install
  3. pnpm run dev
  `)
  );
}, E = g.cliConfig.moduleName, q = (e, o) => {
  console.log(e ? t.red(e) : t.red(o.message)), process.exit(1);
}, G = g.description, z = `$0 ${E} [projectName]`, K = "$0 [projectName]", T = async (e, o) => e.strict().usage(`Usage: ${o}`).help("help").version(g.version).alias("v", "version").alias("h", "help").command({
  command: o,
  describe: G,
  handler: x
}).fail(q).argv, se = {
  command: E,
  describe: G,
  builder: (e) => T(e, z),
  handler: x
}, ne = async () => {
  const e = M(O(process.argv));
  return await T(e, K);
};
export {
  se as a,
  ne as c,
  x as h
};
